JBUFSIZE		equ		4096

IJLibVersion struct
	major			DD		?
	minor			DD		?
	build			DD		?
	Name_			DD		?
	Version			DD		?
	InternalVersion	DD		?
	BuildDate		DD		?
	CallConv		DD		?
IJLibVersion ends

IJL_RECT struct
	left	DD		?
	top		DD		?
	right	DD		?
	bottom	DD		?
IJL_RECT ends

IJL_SETUP		equ		-1
IJL_JFILE_READPARAMS		equ		0
IJL_JBUFF_READPARAMS		equ		1
IJL_JFILE_READWHOLEIMAGE		equ		2
IJL_JBUFF_READWHOLEIMAGE		equ		3
IJL_JFILE_READHEADER		equ		4
IJL_JBUFF_READHEADER		equ		5
IJL_JFILE_READENTROPY		equ		6
IJL_JBUFF_READENTROPY		equ		7
IJL_JFILE_WRITEWHOLEIMAGE		equ		8
IJL_JBUFF_WRITEWHOLEIMAGE		equ		9
IJL_JFILE_WRITEHEADER		equ		10
IJL_JBUFF_WRITEHEADER		equ		11
IJL_JFILE_WRITEENTROPY		equ		12
IJL_JBUFF_WRITEENTROPY		equ		13
IJL_JFILE_READONEHALF		equ		14
IJL_JBUFF_READONEHALF		equ		15
IJL_JFILE_READONequARTER		equ		16
IJL_JBUFF_READONequARTER		equ		17
IJL_JFILE_READONEEIGHTH		equ		18
IJL_JBUFF_READONEEIGHTH		equ		19
IJL_JFILE_READTHUMBNAIL		equ		20
IJL_JBUFF_READTHUMBNAIL		equ		21

IJL_RGB		equ		1
IJL_BGR		equ		2
IJL_YCBCR		equ		3
IJL_G		equ		4
IJL_RGBA_FPX		equ		5
IJL_YCBCRA_FPX		equ		6
IJL_OTHER		equ		255

IJL_NONE		equ		0
IJL_411		equ		1
IJL_422		equ		2
IJL_4114		equ		3
IJL_4224		equ		4


HUFFMAN_TABLE struct
	huff_class	DD		?
	ident		DD		?
	huffelem	DD		256 DUP (?)
	huffval		DW		256 DUP (?)
	mincode		DW		17 DUP (?)
	maxcode		DW		18 DUP (?)
	valptr		DW		17 DUP (?)
HUFFMAN_TABLE ends

JPEGHuffTable struct
	bits		DD		?
	vals		DD		?
	hclass		DB		?
	ident		DB		?
JPEGHuffTable ends

QUANT_TABLE struct
	precision	DD		?
	ident		DD		?
	elements	DD		?
	elarray		DW		84 DUP (?)
QUANT_TABLE ends

JPEGQuantTable struct
	quantizer	DD		?
	ident		DB		?
JPEGQuantTable ends

FRAME_COMPONENT struct
	ident		DD		?
	hsampling	DD		?
	vsampling	DD		?
	quant_sel	DD		?
FRAME_COMPONENT ends

_FRAME struct
	precision		DD		?
	width_			DD		?
	height			DD		?
	MCUheight		DD		?
	MCUwidth		DD		?
	max_hsampling	DD		?
	max_vsampling	DD		?
	ncomps			DD		?
	horMCU			DD		?
	totalMCU		DD		?
	comps			DD		?
	restart_interv	DD		?
	SeenAllDCScans	DD		?
	SeenAllACScans	DD		?
_FRAME ends

SCAN_COMPONENT struct
	comp		DD		?
	hsampling	DD		?
	vsampling	DD		?
	dc_table	DD		?
	ac_table	DD		?
	quant_table	DD		?
SCAN_COMPONENT ends

SCAN struct
	ncomps			DD		?
	gray_scale		DD		?
	start_spec		DD		?
	end_spec		DD		?
	approx_high		DD		?
	approx_low		DD		?
	restart_interv	DD		?
	curxMCU			DD		?
	curyMCU			DD		?
	dc_diff			DD		4 DUP (?)
	comps			DD		?
SCAN ends

IJL_AAN		equ		0
IJL_IPP		equ		1

IJL_BOX_FILTER		equ		0
IJL_TRIANGLE_FILTER		equ		1

SAMPLING_STATE struct
	top_row			DD		?
	cur_row			DD		?
	bottom_row		DD		?
	last_row		DD		?
	cur_row_number	DD		?
SAMPLING_STATE ends

IJL_OTHER_PROC		equ		0
IJL_PENTIUM_PROC		equ		1
IJL_PENTIUM_PRO_PROC		equ		2
IJL_PENTIUM_PROC_MMX_TECH		equ		3
IJL_PENTIUM_II_PROC		equ		4
IJL_PENTIUM_III_PROC		equ		5
IJL_PENTIUM_4_PROC		equ		6
IJL_NEW_PROCESSOR		equ		7

RAW_DATA_TYPES_STATE struct
	data_type	DD		?
	raw_ptrs	DD		4 DUP (?)
RAW_DATA_TYPES_STATE ends

ENTROPYSTRUCT struct
	offset_				DD		?
	dcval1				DD		?
	dcval2				DD		?
	dcval3				DD		?
	dcval4				DD		?
	bit_buffer_64		DD		2 DUP (?)
	bitbuf_bits_valid	DD		?
	unread_marker		DB		?
ENTROPYSTRUCT ends

STATE struct
	bit_buffer_64			DD		2 DUP (?)
	bit_buffer_32			DD		?
	bitbuf_bits_valid		DD		?
	cur_entropy_ptr			DD		?
	start_entropy_ptr		DD		?
	end_entropy_ptr			DD		?
	entropy_bytes_processed	DD		?
	entropy_buf_maxsize		DD		?
	entropy_bytes_left		DD		?
	Prog_EndOfBlock_Run		DD		?
	DIB_ptr					DD		?
	unread_marker			DB		?
	processor_type			DD		?
	cur_scan_comp			DD		?
	file					DD		?
	JPGBuffer				DB		4096 DUP (?)
STATE ends

IJL_NO_CC_OR_US		equ		0
IJL_111_YCBCR_111_RGB		equ		1
IJL_111_YCBCR_111_BGR		equ		2
IJL_411_YCBCR_111_RGB		equ		3
IJL_411_YCBCR_111_BGR		equ		4
IJL_422_YCBCR_111_RGB		equ		5
IJL_422_YCBCR_111_BGR		equ		6
IJL_111_YCBCR_1111_RGBA_FPX		equ		7
IJL_411_YCBCR_1111_RGBA_FPX		equ		8
IJL_422_YCBCR_1111_RGBA_FPX		equ		9
IJL_1111_YCBCRA_FPX_1111_RGBA_FPX		equ		10
IJL_4114_YCBCRA_FPX_1111_RGBA_FPX		equ		11
IJL_4224_YCBCRA_FPX_1111_RGBA_FPX		equ		12
IJL_111_RGB_1111_RGBA_FPX		equ		13
IJL_1111_RGBA_FPX_1111_RGBA_FPX		equ		14
IJL_111_OTHER_111_OTHER		equ		15
IJL_411_OTHER_111_OTHER		equ		16
IJL_422_OTHER_111_OTHER		equ		17
IJL_YCBYCR_YCBCR		equ		18
IJL_YCBCR_YCBYCR		equ		19

JPEG_PROPERTIES struct
	iotype					DD		?
	roi						IJL_RECT	<?>
	dcttype					DD		?
	fast_processing			DD		?
	interrupt_				DD		?
	DIBBytes				DD		?
	DIBWidth				DD		?
	DIBHeight				DD		?
	DIBPadBytes				DD		?
	DIBChannels				DD		?
	DIBColor				DD		?
	DIBSubsampling			DD		?
	DIBLineBytes			DD		?
	JPGFile					DD		?
	JPGBytes				DD		?
	JPGSizeBytes			DD		?
	JPGWidth				DD		?
	JPGHeight				DD		?
	JPGChannels				DD		?
	JPGColor				DD		?
	JPGSubsampling			DD		?
	JPGThumbWidth			DD		?
	JPGThumbHeight			DD		?
	cconversion_reqd		DD		?
	upsampling_reqd			DD		?
	jquality				DD		?
	jinterleaveType			DD		?
	numxMCUs				DD		?
	numyMCUs				DD		?
	nqtables				DD		?
	maxquantindex			DD		?
	nhuffActables			DD		?
	nhuffDctables			DD		?
	maxhuffindex			DD		?
;	jFmtQuant				QUANT_TABLE		4 DUP (<?>)
;	jFmtAcHuffman			HUFFMAN_TABLE	4 DUP (<?>)
;	jFmtDcHuffman			HUFFMAN_TABLE	4 DUP (<?>)
	jEncFmtQuant			DD		4 DUP (?)
	jEncFmtAcHuffman		DD		4 DUP (?)
	jEncFmtDcHuffman		DD		4 DUP (?)
	use_external_qtables	DD		?
	use_external_htables	DD		?
;	rawquanttables			JPEGQuantTable	4 DUP (<?>)
;	rawhufftables			JPEGHuffTable	8 DUP (<?>)
	HuffIdentifierAC		DB		4 DUP (?)
	HuffIdentifierDC		DB		4 DUP (?)
	jframe					_FRAME	<?>
	needframe				DD		?
	jscan					DD		?
	state					STATE	<?>
	SawAdobeMarker			DD		?
	AdobeXform				DD		?
	rowoffsets				DD		?
	MCUBuf					DD		?
	tMCUBuf					DB		1440 DUP (?)
	processor_type			DD		?
	raw_coefs				DD		?
	progressive_found		DD		?
	coef_buffer				DD		?
	upsampling_type			DD		?
	sampling_state_ptr		DD		?
	AdobeVersion			DW		?
	AdobeFlags0				DW		?
	AdobeFlags1				DW		?
	jfif_app0_detected		DD		?
	jfif_app0_version		DW		?
	jfif_app0_units			DB		?
	jfif_app0_Xdensity		DW		?
	jfif_app0_Ydensity		DW		?
	jpeg_comment			DD		?
	jpeg_comment_size		DW		?
JPEG_PROPERTIES ends

JPEG_CORE_PROPERTIES struct
	UseJPEGPROPERTIES	DD		?
	DIBBytes			DD		?
	DIBWidth			DD		?
	DIBHeight			DD		?
	DIBPadBytes			DD		?
	DIBChannels			DD		?
	DIBColor			DD		?
	DIBSubsampling		DD		?
	JPGFile				DD		?
	JPGBytes			DD		?
	JPGSizeBytes		DD		?
	JPGWidth			DD		?
	JPGHeight			DD		?
	JPGChannels			DD		?
	JPGColor			DD		?
	JPGSubsampling		DD		?
	JPGThumbWidth		DD		?
	JPGThumbHeight		DD		?
	cconversion_reqd	DD		?
	upsampling_reqd		DD		?
	jquality			DD		?
	jprops				JPEG_PROPERTIES		<>
JPEG_CORE_PROPERTIES ends

IJL_OK					equ		0
IJL_INTERRUPT_OK			equ		1
IJL_ROI_OK				equ		2
IJL_EXCEPTION_DETECTED			equ		-1
IJL_INVALID_ENCODER			equ		-2
IJL_UNSUPPORTED_SUBSAMPLING		equ		-3
IJL_UNSUPPORTED_BYTES_PER_PIXEL		equ		-4
IJL_MEMORY_ERROR			equ		-5
IJL_BAD_HUFFMAN_TABLE			equ		-6
IJL_BAD_QUANT_TABLE			equ		-7
IJL_INVALID_JPEG_PROPERTIES		equ		-8
IJL_ERR_FILECLOSE			equ		-9
IJL_INVALID_FILENAME			equ		-10
IJL_ERROR_EOF				equ		-11
IJL_PROG_NOT_SUPPORTED			equ		-12
IJL_ERR_NOT_JPEG			equ		-13
IJL_ERR_COMP				equ		-14
IJL_ERR_SOF				equ		-15
IJL_ERR_DNL				equ		-16
IJL_ERR_NO_HUF				equ		-17
IJL_ERR_NO_QUAN				equ		-18
IJL_ERR_NO_FRAME			equ		-19
IJL_ERR_MULT_FRAME			equ		-20
IJL_ERR_DATA				equ		-21
IJL_ERR_NO_IMAGE			equ		-22
IJL_FILE_ERROR				equ		-23
IJL_INTERNAL_ERROR			equ		-24
IJL_BAD_RST_MARKER			equ		-25
IJL_THUMBNAIL_DIB_TOO_SMALL		equ		-26
IJL_THUMBNAIL_DIB_WRONG_COLOR		equ		-27
IJL_BUFFER_TOO_SMALL			equ		-28
IJL_UNSUPPORTED_FRAME			equ		-29
IJL_ERR_COM_BUFFER			equ		-30
IJL_RESERVED				equ		-99
